<?php
function exit_error($msg)
{
    fwrite(STDERR,"ERROR : $msg");
    exit(1);
}

$SN_FILE = "/etc/gesa/sn";
$OUT_FILE = "/tmp/gesa/server_url";
$OUT_ALT_FILE = "/var/log/gesa_server_url";

$URL = "http://infogesa.esia-network.com";
$FILE = "api_gesa.php";

$sn = @trim(file_get_contents("$SN_FILE"));
if( empty($sn) ) exit_error("Unable to read SN in $SN_FILE file\n");

$dataxml = trim(file_get_contents("$URL/$FILE?SN=$sn&action=info"));

$dom = new DomDocument();
if( empty($dataxml) || !$dom->loadXML($dataxml) ) exit_error("Unable to get XML response from $URL server\n");

$server_url=$dom->getElementsByTagName("server_url")->item(0)->nodeValue;
if(empty($server_url)) exit_error("Unable to read server url from XML response\n");

if(!is_dir("/tmp/gesa"))
{
    if(!mkdir("/tmp/gesa"))
    {
        exit_error("Can't create directory: /tmp/gesa/\n");
    }
}
if(!preg_match('#\:[0-9]*$#', $server_url))
{
    $server_url .= "/ws";
}

if(!@file_put_contents($OUT_FILE, "$server_url\n")) exit_error("Unable to write in $OUT_FILE\n");
if(!@file_put_contents($OUT_ALT_FILE, "$server_url\n")) exit_error("Unable to write in $OUT_ALT_FILE\n");

echo "SUCCESS : Server url $server_url saved in $OUT_FILE\n";
?>
